\pm Custom Help \ Starting and Termination
\p Starting and Termination \ Starting Program


	To run from the CLI or a script put all of the Data Files\
and Auxiliary Files in\
their own directory (hereinafter simply called the CH Directory),\
then assign the name "CHData:" to that directory using the Command\
"Assign CHData: DIRECTORY" where DIRECTORY is the full path name of\
the directory containing the Data Files. Put the "CH" program file\
into the C: directory.

	To run from WorkBench open the CustomHelp drawer and double click\
the CH program icon.

	CH requires the files CH.cmd and CH.prefs for it's Command configuration\
and preferences respectively. When started it will look for these\
files in the CH Directory. If either file can not be found in the\
proper directory the program will terminate immediately.

	The optional file, CH.menu, defines the menus. Menus are not necessary
for program operation. This file, if used, must also be in the CH Directory.

	Most program options are set at startup from the CH.prefs File.\
If any Startup Option is used, it will override the value taken from\
the CH.prefs File. All of the of the other options may be changed during\
program execution. To make the changes\
permanent, choose "SAVE" on the User Input Window where the option appears, or\
execute the Save Preferences Instruction. These changes will be saved in the\
CH.prefs file and used the next time the program is started.

	CH is started from the CLI with the Command "CH". CH runs\
as a background task, so it is not necessary\
to "run" the program. On startup, the program will look for any file matching\
the "Base.#?" pattern in the CH Directory. These files will be opened\
and a Base Page will be built.

	CH is started from WorkBench by clicking on the program icon. Use\
the "info" WorkBench menu item to alter the Startup Options.

	The startup message will tell you the configured Hot Key and Qualifier.

\r\Files/CH.prefs File
\r\Files/CH.cmd File
\r\Files/CH.menu File
\p Startup Options


	The Startup Options consist of the Command line switches, if started\
from the CLI, or the Tool Types array, if started from the WorkBench Screen.

	Although you are not required to specify a WorkBench Output Window, be aware\
that if you run CH from WorkBench without an output window, there will\
be no indication that the program has started.

	Startup Options have precedence over the CH.prefs File values.\
Options are provided to set the\
Hot Key, Hot Key Qualifiers, CH Directory and WorkBench Output\
Window.

	Each option must be given with the option name or first letter,\
an equals sign "=", then the option value or values, with no\
intervening spaces.

Hot Key Option:
\l3	This may be set to any\
key on the keyboard except the qualifier keys (Control, Shift, etc.).

	If the key you wish to use is one of the normally printable keys,\
specify it with the character itself.\
The normally printable keys are those that print a single character,\
without the qualifiers Alternate or Control.\
Case is insignificant for the key specified.\
If you want an upper case letter specify a shift for the qualifier rather\
than an upper case letter. Numeric keys specified by this method will\
default to the top row of numeric keys on the keyboard rather than the\
numeric keypad on the right hand side.

	If you want to use one of the\
non-printable keys (BACKSPACE, DELETE, etc.) or the numeric keypad keys,\
select a key name from the\
list below. You may enter just enough of the name to completely distinguish the\
it from all of the others. For the DELETE key, DEL is enough.
\w
\l6	Key Names:
		Function Keys --  F1, F2, F3, F4, F5, F6, F7, F8, F9, F10
		Numeric Keypad -- KP0, KP1, KP2, KP3, KP4,
								KP5, KP6, KP7, KP8, KP9,
								KP(, KP), KP/, KP*, KP-, KP+, KP., ENTER
		Arrow Keys --     UP, DOWN, LEFT, RIGHT
		Others --         SPACE, BACKSPACE, TAB, ESCAPE, DELETE,
								HELP, RETURN

Examples:
		"KEY=a" for the 'a' key
		"K=/" for the '/' key
		"KEY=ESCAPE"
		"K=KP5"
\W
\l
Hot Key Qualifier:
\l3	This may be any\
combination of the Shift, Alternate and Control qualifier keys.\
If using Shift or Alternate, specify the left or right key.\
When using multiple qualifiers, seperate each qualifier by a dash "-".\
The qualifier names listed below may be abbreviated to the first\
one or two letters, enough to distinguish the name from all of the others.

\l		Use:
			"LShift" = Left Shift
			"RShift" = Right Shift
			"LAlternate" = Left Alternate
			"RAlternate" = Right Alternate
			"Control" = Control
			
\l6Examples:
		"Q=LShift-Control"
		"QUALIFIERS=RA-C" specifys the RightAlternate-Control keys.
		"Q=C" for Control key
\l
CH Directory:
\l3	The default is the "CHData:" directory, if assigned, the current\
directory if not. If an alternate\
CH Directory is desired use this option to specify the new directory.

\l6Examples:
		"DIRECTORY=dirname"
		"D=dirname"
\l
WorkBench Output Window:
\l3	If starting from WorkBench, an output window may be specified to\
receive any messages that would normally go to the CLI.\
You may specify any size, position (within the bounds of the WorkBench\
Screen) and window title desired.

\l6Examples:
		"WINDOW=NO" for no output window.
		"W=NO"
		"WINDOW=CON:0/0/500/50/Custom Help" for an output\
window at location 0, 0 with a size of 500 x 50 and the title "Custom Help".

\p Terminate Program


	Open the DW and execute the Terminate Program Instruction.

