\pm Custom Help \ Using the Program
\p Using the Program \ Opening and Closing the DW


	To open the DW, after starting the program, enter the Hot Key\
combination. Check the startup message for the configured Hot Key\
and Qualifier.

	CH will open it's own screen with the DW as a backdrop window.\
The screen size will match your WorkBench Screen, so if you have set\
overscan rows or columns, these will be also used for the CH Screen.

	The DW may be shortened by specifying a lower number of display rows than\
a full screen. This is useful for dragging the CH Screen to the lower\
half of the display to view the DW and application program at the\
same time.

	If the font named in the CH.prefs file is proportional or\
can not be found, CH will use the default system font. This font should be\
non-proportional and will then become the font that will be used from\
this point foreward by the program. The font may be changed to any\
non-proportional font with the Edit Display Values window, then saved\
to make your choice permanent.

	To leave the DW and return to Standby Mode execute the Close Window\
Instruction.

\p DW Gadgets and Areas

\w
	The DW is divided into the following areas:

|---------------------------------------------------------------------|
| Title Area                               Row:     Col:              |
|---------------------------------------------------------------------|
|M1|                                                              |   |
|M2|                                                              |   |
|M3|                                                              | S |
|M4|                                                              | C |
|M5|                                                              | R |
|M6|                                                              | O |
|M7|                                                              | L |
|M8|                    Information Area                          | L |
|M9|                                                              |   |
|10|                                                              | G |
|WW|                                                              | A |
|QC|                                                              | D |
|RI|                                                              | G |
|XA|                                                              | E |
|--|                                                              | T |
|                                                                 |   |
|---------------------------------------------------------------------|
| Message Area                                                        |
|---------------------------------------------------------------------|
\W
	Title Area:
\l6
	The Title Area usually contains the program name and a note that\
you may use the HELP key at any time for a list of Instructions.\
It is also used to indicate Command Read Mode, Command Edit Mode, etc.\
The right hand side of the Title Area contains the row and column\
numbers of the currently viewed page.
\l
Scroll Gadget:
\l6
	Along the right hand side of the DW is a Scroll Gadget used to\
scroll page data for pages larger than the window information Area.
\l
Gadget Area:
\l6
	The left hand side of the DW contains a group of gadgets. The\
first ten are used for Marks the same as the ten function keys along\
the top row of the keyboard. Clicking on one of the gadgets will display\
the associated Mark. Holing the shift key and clicking a gadget will\
set a Mark and holding the alt key and clicking a gadget will clear a\
Mark. If a Mark is set the associated Mark Gadget will be highlighted.

	Under the Mark Gadgets are four indicators, three of which are also\
gadgets.
	1. WW - Word Wrap active. Click this gadget to toggle Word Wrap.
	2. QC - Quick Commands. Also a toggle.
	3. RI - Related Items. Click to display.
	4. XA - Export Active. Indicates an Export function is active.
\l
Message Area:
\l6
	At the bottom of the window is the Message Area. This area is used for\
several functions.

	1. Display the path information for the current page.
	2. Non-critical information messages.
	3. Display of entered Command and possible Commands.
	4. Prompt for additional data.
\l
Information Area:
\l6
	This is the rest of the DW. The page data is displayed here.

\p Messages


	Program messages are displayed in several different ways, depending on\
the type of message. There are three types of messages. Information only,\
non-critical error and critical error messages.

\l3Information only:
	These messages will appear in the Message Area of the DW for a short\
time only. They will be replaced immediately when a new message is ready to\
be displayed. If the DW is not open these will not be displayed. Some\
messages of this type are "Loading <Data File>", "Searching for <word>", etc.

Non-critical Error:
	These messages also appear in the Message Area but can not be replaced by\
another message till a time-out period has expired. This enables the user\
time to read the message. Any user input will end the time-out period.\
Press any unused key to refresh the display, getting rid of any non-critical\
messages before the end of their time-out.\
If the DW is not open these will not be displayed.\
Some messages of this type are "Edit Options canceled.", "Page not found.",\
etc.

Critical Error:
	These will appear in one of several places depending on circumstances.

\l6	1. If the DW is open a message window will be opened on top of the DW.\
The user will have to acknowledge the message before he can continue\
program operation. Acknowledging the message can be accomplished by either\
clicking on the "Continue" gadget or pressing any key.

	2. If the DW is not open and the program was started from a CLI or\
shell the message will be displayed in the CLI or shell window.

	3. If the DW is not open and the program was started from WorkBench\
the message will appear in the Output Window, if one was specified.

\l3	Some messages of this type are "Not enought memory for ...",\
"Could not open CH screen.", etc.

Slow Messages:
	This is an option that will cause a delay of one second after every message\
that appears in the Message Area of the DW (the Information Only and\
Non-Critical Error messages). The Information Only messages can flash\
by on the display too fast to read. When trying to determine what the\
program is doing it is sometimes helpful to slow down these messages.

\p Operation Overview


	There are two ways in which to initiate an Instruction, the window\
menu strip or the Command. The Command is the preferred method. The\
character string on the right of each menu item is the Command. CH\
Commands do not use the right Amiga key.

	The Commands are configured using the Command Edit instruction.\
Command can use any of the printable keys except the ESCAPE and BACKSPACE\
keys. Commands can use the shift key as a modifier\
for possibly dangerous instructions (removing files\
from memory, clearing Marks, terminating CH, etc.). See\
Data Files/CH.cmd File for details.
\r\Files/CH.cmd File

	To get a complete list of Instructions while viewing the DW\
press the HELP key. If a line in the Info Page starts with a number\
this is a configurable instruction. The number is the internal instruction\
number and is needed for composing the menus. When done\
viewing the HELP key info press any key other than a scrolling key\
to return to the page you were previously viewing.

	The bottom line of the display window is for page path information,\
program status, Command options and operator error information. Error\
messages that appear in the message area of the DW will remain for\
a short time then be replaced by the next message.

	All keys that are not assigned to an Instruction will refresh the\
DW. This may be used to remove a message from the bottom line of the\
window before the message time-out. This is also useful when the DW\
is opened on a Custom Screen that overwrites the DW text.

	All configurable Commands are repeatable using the Repeat Command.

\p Commands


	There are two types of Command, the configurable Commands and the\
hardwired Commands. The configurable Commands consist of from one to\
twenty printable characters. Each configurable Command executes a specific\
Instruction. The hardwired Commands use the function, scrolling\
and numeric keys. The function keys display, set and clear marks.\
The scrolling keys scroll page data. The numeric key are used for entering\
a Child Page number.

	Commands may use either the numeric keys along the top line of the\
keyboard or the keypad numeric keys. Also the RETURN or keypad ENTER\
keys may be used interchangably.

	CH uses a type ahead feature, making it possible to type Commands\
without waiting for previous entries to finish. Press the ESCAPE key\
to discard typed ahead characters. You may even type into\
the string gadget of the General Input Window before the window is\
opened. The General Input Window is used\
for several Instructions (Page Search, Word Search, etc.).

	When a key is pressed CH goes through a series of\
checks to determine what should be done.
\l3
	First, the hardwired Commands are checked. If the key pressed\
is a function or scrolling key, that Command is executed immediately.

	Second, if the key pressed is a numeric key and CH is not in Command\
Read Mode, CH will either access the Child Page or enter Command Read\
Mode, depending on the number of Child Pages in the current group and the\
state of Quick Commands.

	Third, the character is checked against the configurable Commands.\
CH either executes the Instruction, enters Command Read Mode or flashes\
the screen, depending on circumstances (see below).

	Fourth, if none of the above conditions exist the path information\
is refreshed. Pressing any unused keys is a quick way of removing any\
message and replacing the page path after you have read the message.
\l

	CH has two methods of entering configurable Commands and Child Page\
numbers. The first, Quick Commands,\
allows Instructions to be executed with either a single or multiple keystrokes.\
The second, normal Commands, requires entering the entire Command, then\
the pressing the RETURN key.

	Quick Commands:
\l6	This type of Command entry allows the use of single keystroke\
Instruction execution. When the entire Command\
is entered the Instruction is executed immediately, there is no need to press the\
RETURN key, but it can be made a part of the Command, if desired. If the entered\
value does not complete a Command but there is only one "Possible" Command,\
you may press the RETURN key to execute it.

	If the first Command key entered is a numeric key, CH will enter Command\
Read Mode if the current Menu Page contains more than 9 Child Pages. If\
less than 9 CH will immediately access the Child Page. Command Read Mode\
will stay active till enough of the child number is entered that there\
can be only one child number that you are entering. If you entered\
the number completely but you are still in Command Read Mode, press\
the RETURN key to access the Child Page.
\l
	Normal Commands:
\l6	This type of Command requires that you enter the entire Command,\
then press the RETURN key to execute the Instruction. If you are entering\
a child number, that must also be terminated with a RETURN key.

\l3Command Read Mode:
	This mode is entered when you enter the first character of a Command,\
if it is not a single character Command and you are using Quick Commands.\
While in this mode the Title line of the DW changes to "Command Read:	\
Press ESCAPE to Abort" and the Message Area of the DW shows the Command,\
as entered up to that point. You\
may use the BACKSPACE key to delete the last character of the entered\
Command or the ESCAPE key to terminate the operation.

	This mode acts a little differently, depending on whether you are using\
Quick Commands or not.

\l6Command Read with Quick Commands:
	In the Message Area of the DW after the Command that you are entering\
will be a list of the "Possible" Commands.The "Possible"\
Commands are those whose beginning characters match the entered value.\
Each time a new character is entered the "Possible" Commands\
are re-calculated and displayed. If the character\
you have just entered does not match any of the Commands,\
the screen will flash and the Command: will not be updated.

	While in Command Read mode no characters will be accepted except those\
that will further define any of the remaining "Possible" Commands. You\
may use the BACKSPACE key to delete the last character of the entered\
value. The "Possible" Commands will be re-displayed. Command Read will\
remain active until an Instruction is executed or the ESCAPE key is\
pressed. An Instruction may be executed by entering the entire Command\
or entering enough of the Command so there is only one "Possible" Command,\
then pressing the RETURN key.

Command Read without Quick Commands:
	Any character may be entered, CH does not check the entered Command\
until the RETURN key is pressed. The "Possible" Commands will not be\
displayed unless the RETURN key is pressed and the entered Command does\
not match any of the configurable Commands.
\l
	Instructions are provided for Editing a Command, Saving the Current\
Commands and Restoring the Commands last saved.

	See Editing Commands for details of the Command Edit instruction.
\rEditing Commands

	After editing Commands, if you wish to make the edited versions\
permanent, execute the Save Commands instruction.\
This will save the current Command configuration to the file CH.cmd.\
The previous configuration will be lost.

	If after Editing Commands, but before saving the new configuration,\
you wish to restore the original Command\
configuration, execute the Restore Commands instruction. This will\
load the CH.cmd file and restore the configuration found there.

\p Editing Commands


	Any configurable Command may be changed by executing the Edit Command\
instruction.

	When the Command Edit instruction is initiated CH enters Command Edit\
mode. The window title changes to "Command Edit:    Press ESCAPE to abort".\
CH waits for the user to enter a valid configurable Command. The same rules\
apply here as in Command Read mode, enter the entire Command or press\
RETURN when there is one "Possible" Command. When the Command has been\
entered the General Input Window appears containing the entered Command. Use\
the normal Intuition editing keys to change the Command.

	Commands:
\l6A.	consist of 1 to 20 printable keys.
B. can not use numeric keys as a first character.
C. can not use the dash '-' or ESCAPE characters.
D. can use any of the other printable keys.
E. are case sensitive ('d' and 'D' are not the same).
F. must each be unique to the length of the Command (if you have a\
single character Command of 'd', no other Commands may start with a\
'd').
\l
	The Command Edit instruction ensures the above rules are followed.

	The Command may be divided in two parts with the dash '-'. The part\
of the Command before the dash will be used for\
Command execution and in the menu items. The full Command will be used\
for the Info Page and in the list of "Possible" Commands. This allows\
you to have a short logical Command and display a short\
description of the associated Instruction in the "Possible" list.

\w	Examples:					"Restart"						"R--Restart"
\l6Type to execute		"Restart"						"R"
Menu Item contains	"Resta"							"R"
"Possible" list		"Restart"						"R--Restart"
\W
\lSome things to keep in mind when making up your own Commands are:

\l3A.	Keep the often used Commands small (one character before the "-"),\
lower case and unique. By\
unique I mean you can't use the character of a single character Command as\
the first character of any other Command. You can execute an instruction\
with this type of\
Command with a single keystroke. Keeping it lower case means you don't\
have to use the shift key.

B.	Make the "Name" portion something you can use to distinguish between\
Commands with the same starting characters. If two or more Commands use\
the same first character they will be displayed in the DW message\
area at the bottom of the window when the first Command character\
is entered.

C.	Keep all the Commands as small as possible.

D. None of the Instructions do anything as dangerous as writing to a\
Data File but some write to auxiliary files (CH.cmd, CH.prefs), unload\
files from memory, or erase Marks, etc. For instructions that\
are dangerous, in this respect, it is advisable to make their Commands a\
little harder to do. I have made these Commands upper case for this\
purpose. You can also make them longer, making it more difficult\
to hit the wrong key.

\l	Normally, the RETURN key does not need to be pressed\
to execute a Command. It is possible to make the RETURN a part of\
the Command by placing the appropiate character, an ASCII Carriage\
Return, (decimal 13), in the Command. When editing the Command\
enter a control-m.

	Other special characters can be used in Commands. Any key that\
does not produce a string for a keystroke can be used in Commands.\
This includes the CONTROL and ALT key combinations. To use these\
enter the special character in the Command Edit string gadget, the\
same as any other character.

\p Instructions by Function


	See Related Items for details of CH instructions.

	Since the Commands are configurable they are not listed. Press the\
HELP key to get a list of Instructions\
along with the currently configured Commands. These Commands may be altered\
using the Command Edit instruction.
\l3
Scrolling:								See Scrolling within a page.

Page to Page:							See Page to Page.
\l6Parent
First Child
Previous Sibling
Next Sibling
Related Item      				See Related Item
Base Page
\rScrolling within a page
\rPage to Page
\l3
Page Search:							See Page Search
\l6Enter Search Page Name
Edit Search Page Name
Continue Page Search Foreward
Continue Page Search Backward
\rPage Search
\l3
Word Search:							See Word Search
\l6Enter Search Word
Edit Search Word
Continue Word Search Foreward
Continue Word Search Backward
Toggle Page Only
Toggle Case Sensitivity
\rWord Search
\l3
Memory Management:					See Memory Management
\l6Delete File
Clear Unused Files
Clear Unused and Mark Files
Restart
Toggle Auto Clear
Display Available Memory
\rMemory Management
\l3
Marks:									See Marks
\l6Display Mark
Set Mark
Clear Mark
Display next Mark
Clear All Marks
\rMarks
\l3
Commands:
\l6Repeat Last Command
Toggle Quick Commands
Edit a Command
Save Commands
Restore Commands
\l3
Preferences:
\l6Load Preferences
Save Preferences
\l3
Data Export:
\l6Edit Export Data Values
Export a Page
Export a Group
Export a Page List
Abort Export
\l3
Miscellaneous:
\l6Display Info Page					See Operation Overview
Adjust Colors
Last History Page      			See History Buffer
Next History Page					See History Buffer
Enter Hist. Buffer Positions
Toggle Word Wrap Mode   		See Word Wrap
Toggle Slow Messages				See Messages
Edit Display Values
Close DW     						See Opening and Closing
Terminate CH     					See Starting and Term/Terminate Program
\rOperation Overview
\rHistory Buffer
\rWord Wrap
\rMessages
\rRelated Item
\rOpening and Closing
\r\Starting and Term/Terminate Program

\p Instructions by Number


	See Related Items for details of CH instructions.

	This is the numerical list of Instructions. The Instruction\
number is necessary when composing the menus.
\l3

 0.	Up to Parent
 1.	Down to First Child
 2.	Previous Child
 3.	Next Child
 4.	Terminate Program
 5.	Related Items
 6.	Base Page
 7.	Page Search
 8.	Edit Page Search
 9.	Word Search
10.	Edit Word Search
11.	Toggle Case Sensitivity
12.	Next Search Word
13.	Last Search Word
14.	Next Search Page
15.	Last Search Page
16.	Restart
17.	Available Memory
18.	Clear Unused Files
19.	Clear All Files
20.	Next Mark
21.	Clear Marks
22.	Help
23.	Last History Page
24.	Next History Page
25.	Togggle Word Wrap
26.	Close Display Window
27.	Clear File
28.	Repeat Last Command
29.	Edit Display Valuess
30.	Edit Command
31.	Save Commands
32.	Load Commands
33.	Load Prefs
34.	Save Prefs
35.	Export Page
36.	Export Group
37.	Export Abort
38.	Toggle Quick Commands
39.	Adjust Colors
40.	Edit Export Values
41.	Slow Messages
42.	Export Page List
43.	Toggle Auto Clear
44.	Toggle Word Search Page Only
45.	Enter History Buffer Positions
\rScrolling within a page
\rPage to Page
\rPage Search
\rWord Search
\rMemory Management
\rMarks
\rOperation Overview
\rHistory Buffer
\rWord Wrap
\rRelated Item
\rOpening and Closing
\r\Starting and Term/Terminate Program
\pm \ User Input Windows


	1.	General Input

	2.	Edit Display Values

	3.	Edit Export Values

	4.	Adjust Colors

	5.	Related Items

\W
	For all of the Input Windows, use of the mouse is necessary only\
for the proportional gadgets of the Alter Colors Window. Windows that\
contain string, numeric, boolean and limited gadgets, may have all\
of these gadgets accessed either with the mouse or the keyboard.

	When the window is opened the pointer is moved into the window,\
sometimes into a gadget,  and the window or gadget is made active.\
This is convenient if using a utility that automatically activates\
the window where it appears.

	The boolean gadgets in the Input Window may be accessed by a\
mouse click, as normal, or with the first letter of the name\
(S for "Save", U for "Use" and C for "Cancel). Use of the letter\
is only valid if none of the gadgets in the window is active. If\
the window contains only one boolean gadget, it may be activated\
with any key.

	For any Input Window containing multiple input gadgets\
(Alter Colors, Edit Display Values and Edit Export Values), the window\
opens with a highlight box around the first gadget.
\w
	Using the highlight box:

		Moving the highlight box:
			1. When none of the input gadgets is selected, press one of
				the arrow keys.
			2. Click on the gadget with the mouse pointer.

		Activating an input gadget:
			1. Move the highlight box to the gadget and press RETURN.
			2. Click on the gadget with the mouse.

		De-selecting a gadget:
			Press RETURN.
\W
	Any of the windows may be canceled with the ESCAPE key, if\
no input gadget is selected.

Limited gadgets:
	I have implemented a version of gadget I call a limited gadget. This type\
is used when there is only a small number of valid input values. In the\
Edit Display Values Window this type is used for the Interlace, Raised Letters\
and Colors values. Clicking with the mouse or activating with the highlight\
box will cycle these gadgets through their valid values.

	The User Input Windows may be repositioned and will re-appear on\
subsequent invocations of that window at the last position.

\PC User Input Windows \ General Input


	The General Input Window is used when requesting single value\
information or posting error messages.

	When the user requests any instruction that requires additional,\
single value, information CH opens a General Input Window. These\
instructions are entering a Page Name for a search and entering a\
search word and entering a new number of History Buffers.
\r\Page Search
\r\Word Search

	Serious error messages appear in a General Input Window. CH will wait\
for a user response before continuing. Hit any key to continue.

\p Edit Display Values


	This window allows you to alter the values associated with the DW\
appearance.

	It's values are:
		Tabsize
		Margins
		Display Rows
		Font
		Font Size
		Page Name Style
		Interlace
		Colors
		Raised Letters

	This window starts with a highlight box around the Tabsize value. Use\
the RETURN and arrow key as described in the All Input Windows section.

	The Display Rows value contains the number of lines on the DW to be used\
for displaying the page data. This may be any number from 5 to 50. If the\
number exceeds the number of rows that will fit on the screen, it will be\
adjusted when it is run. I normally leave this set to 50 to use the entire\
screen, so I don't have to change it if I change the font size.

	The font name and size allows you to specify any font and size, but will\
only change them if the font selected can be found and is non-proportional.\
If you are using AmigaDOS 2.0 or later any font size can be specified and\
the font will be scaled. You may leave the font name blank to use the\
default system font.

	The Page Name Style string is used to set the position, style and colors\
of every Page Name. This string can include any of the Text Style\
Characters and Paragraph Indent for leading spaces. Any other characters will\
be ignored. The string you use will be applied to only the Page Name of each page\
as it is displayed, it is not necessary to turn off these styles with the "\\o"\
character sequence after the Page Name. If the Data File contains style or\
indent characters for the Page Name, these will override your settings.\
See Files/Text Style Characters and Files/Word Wrap Specifiers for details.
\r\\Files/Text Style Characters
\r\\Files/Word Wrap Specifiers

	Interlace if a limited gadget with values of YES or NO only. It determines\
whether the CH screen will be in Interlace mode or not. Interlace requires\
more memory than non-interlace. Move the\
highlight box to it and press RETURN to change.

	Colors is also a limited gadget. It's possible values are 2, 4 or 8. This\
will specify a screen of 1, 2 or 3 planes, respectively. The more planes\
the better the DW appearance and the more memory used.

	Raised Letter is either YES or NO. They use no more memory and do not\
significantly slow down the display. If you like them, use them.\
If not, don't.

	At the bottom of the window is the "Save", "Use" and "Cancel" gadgets.\
Click with the mouse, or type the first letter when none of the input\
gadgets is selected, to activate. "Save" will save the current values to\
the CH.prefs file for use the next time the program is started. "Use" will\
use the current values without saving them.

\p Edit Export Values


	This window allows you to edit the values for the Export facility.

	In the following explanation, "page" will sometimes refer to a\
printed page, at other times a CH page. I will make the distinction\
in each case. The printed page length is\
the length of the paper you will be printing on. A CH page may\
be any length.

	It's values are:
		To:						Where to send the exported data
		Page Length				1 to 9999
		Page Width				10 to 999
		Left Margin
		Page form feeds		YES or NO
		List related items	YES or NO
		Send Printer Codes	YES or NO

	This window starts with a highlight box around the "To:" value. Use\
the RETURN and arrow key as described in the User Input Windows section.
\r\User Input Windows
	The "To:" value determines the destination of the Export data. Any\
file name or the printer "PRT:" are valid.

	Page Length: This is primarily used to send a form feed to the printer\
after every printer page. Set to 9999 to prevent printer page form feeds.

	Page Width: The width of the printed page. CH will Word Wrap the Export\
data determined by the width set here, not the DW width.

	Left Margin: This allows a left margin, for placing\
your printed output in a binder.

	Page Form Feeds: Places a form feed at the bottom of every CH page.

	List Related Items: If a CH page includes Related Items, this will\
print a list of them at the end of each CH page. This is the same list\
that would appear in the Related Item window when the Related Item\
instruction is executed.

	Send Printer Codes: If a page contains style special characters,\
this item will convert them into their associated printer control codes.\
The style characters set foreground and backgroud colors, bold, underline\
and italic.

\p Adjust Colors


	This window allows you to set the CH screen colors.

	In a row along the top of the window are the screen colors. The number\
of colors depends on the number selected with the Edit Display Values\
window. When the window is opened, the first color box on the left\
will be selected with the highlight box. Use the arrow keys or the mouse\
to move the highlight box. Use the proportional gadgets in the center\
of the window to adjust the highlighted color.

	For the raised letter and gadget box appearance color 0, on the left\
should be an intermediate color, color 1 should be white and color 2 black.

\p Related Items


	This window displays a list of the Related Items for the displayed\
page and allows you to select and go to one of them. The page contains\
ten spaces, if there are more items, you may scroll the displayed list.

	When the window is opened the first Related Item, at the top of the\
window will be highlighted. Use the up and down arrow keys to move the\
highlighted item. If, when you reach the top or bottom of the window,\
there are more items above or below, the list will automatically scroll.

	When you have highlighted the appropiate item, press the RETURN key\
to go immediately to that item. The item may be anywhere in the system\
of CH pages. Return to the original page is facilitated with the\
History instruction.

	To close the Related Item window, without initiating a Related Item\
instruction, press any key other than the RETURN or arrow keys.

\p Using the Program \ Scrolling within a page


	note: in the following descriptions the word "window" refers to the\
			amount of text that will fit in the DW at one time.

	To scroll page data on the Display Window several methods are available.\
Single line scrolling can be done at several speeds, the slower speeds\
use the Blitter and scroll the window one vertical pixel at a time for\
a very smooth scroll. Fast, smooth scrolling is accomplished best using\
only two or four colors on a non-interlaced screen\
with a normal font and size, such as Topaz-8.

	It is possible to preview a page that has been formatted for Word Wrap.\
To preview, first\
turn off Word Wrap. Each of the paragraphs in the page will appear on a\
single line. Scroll the text till the paragraph you wish to view is at the\
top of the DW. Using the mouse or arrow keys allows scrolling past the\
last full window. Now, turn Word Wrap back on. The entire paragraph will now\
be displayed. When scrolling beyond the last full window of text, the scroll\
gadget will become smaller, reflecting the smaller number of lines now\
visible, compared to the total number of lines in the Page.

	1. Using the scroll gadget:

\l6	On the right hand side of the window is the scroll	gadget. Click on\
the gadget and drag with the left mouse button to the section of the\
current page you wish to display. As you drag the scroll gadget the DW\
will be updated for the current position. Click within the scroll box above the\
scroll gadget to display the next window above the current one. Click within\
the scroll box below the scroll gadget to display the next window below.
\l
	2. Mouse click within the display window:

\l6	By clicking and holding with the left mouse button anywhere inside\
the DW other than the gadget areas you may scroll the page text\
vertically. The speed and direction are determined by the pointer position.\
The pointer may be moved while holding the left mouse button to change the\
speed and direction of text flow. 

	The DW is divided into ten horizontal zones. The pointer in the top\
half of the window will scroll the text down and the pointer in the bottom\
will scroll text up. The text will scroll at five different speeds. When the\
pointer is close to the center of the window the scroll will be slowest. As\
you move the pointer toward the top or bottom of the window the scroll speed\
will increase.
\l
	3. Arrow keys:

\l6	The arrow keys, together with the shift, alternate and control keys\
may be used to scroll the text one line, one window or to the top or bottom\
windows of the current page. Horizontal scrolling is done using the left\
and right arrow keys together with the shift, alternate and control keys.
		
	Single line scrolling with the up and down arrow keys is initially\
done at a speed read in from the CH.prefs file at startup. This may be\
changed during program\
operation by mouse scrolling at the desired speed as described in item 2\
above and pressing either the up or down arrow key. The next time you use\
the up or down arrow key for single line scolling the scroll speed will be\
as set. To make the speed change permanent perform the Save Preferneces\
instruction.
\w
\l9Arrow key usage:
\l12
up-arrow 			Scroll to next line up
shft-up-arrow  	Display next window -1 line up
alt-up-arrow		Display top window
down-arrow  		Scroll to next line down
shft-down-arrow	Display next window -1 line down
alt-down-arrow 	Display bottom window

left-arrow  		Move page to right one character
shft-left-arrow	Move page to right one increment
alt-left-arrow 	Move page to max right position
right-arrow 		Move page to left one character
shft-right-arrow	Move page to left one increment
alt-right-arrow	Move page to left position zero
\l6
note: one increment is one quarter of the display window
note: alt and ctl key may be used interchangibly.
\W
\p Page Search


	To search for a particular page by name (see glossary for Page\
Name), execute the Search Page Name instruction. The General Input\
Window will appear\
requesting the search Page Name. Searches that are initiated from a\
Menu Page will search all the Child Pages of it's group. Searches that\
do not begin at a Menu Page start at the first Child Page of the\
current group through all the Child Pages of that group. The first page\
to match the entered value, truncated to the size of the entered value,\
will end the search. The ESCAPE key is used to abort a Page Search\
Instruction.

	Caution should be used searching from a Parent Page that has Child\
Pages in many different files. In order to find the Page Name it may be\
necessary for CH to load the file containing the Child Page. This could\
be a lot of files. If the External Page\
Specification includes a Page Name, it is not necessary to open the\
file to check the name against the search argument. During the\
search, any files loaded to find a Page Name, that do not contain a\
matching page, will be released from memory.

	A limited wildcard operation is possible. The asterisk '*' may be\
used as the first character of a search name to match any number of any\
characters as the first characters of a Page Name.

	At the beginning of the search string the backslash '\\' is used to\
move back through the Parent Pages before initiating the search\
instruction. Each '\\' at the beginning of the search string will send\
the search up one level before starting. Excess backslashes beyond that\
necessary to go to the Base Page are discarded, so if you want to start\
a search at the Base Page and don't know exactly how many levels down\
you are you can specify more than enough without any problems.

	The name you enter can be truncated down to the number of characters\
necessary to uniquely identify the Page you are searching for. If\
the Page Name is "Amiga control keys" and no other children of the\
current group start with an 'A' entering an 'A' by itself would be\
sufficient to find it.

	If other Child Pages in the current group started with an 'A',\
the search would stop at\
the first match. You could then continue the search with the Continue\
Page Search Foreward Instruction. Use the Continue Page Search Backward\
Instruction to search backward from the currenly displayed page.

	The search string will be saved until a new search string is entered.\
If, after moving away from the last searched page, you execute a Continue\
Search Page Instruction, the last page found will be re-displayed. You may\
then continue the search, either foreward or backward, from that page.

	To search through successive levels separate each level by a slash\
'/'. To get to this page from the Base Page it would only be necessary\
to enter "cu/u/page se" instead of the full path name "Custom Help/Using the\
Program/Page Search". Multi-level searches may be continued either\
foreward or backward.

	If you just wish to alter the last search string entered, rather than\
enter an entirely new name, execute the Edit Search Page Name instruction.\
The same message will appear in the General Input Window along with the\
last search string entered, with the cursor at the end of the name.

\p Word Search


	A Word Search looks for a string of characters. The search may be\
restricted to the currently displayed page or may search an entire group.\
The string of characters may be a part of a word, an entire word or\
multiple words. If the string consists of more than one word, the string\
will only be found it is contained on one display line.

	Case Sensitive Latch:
\l6	The Case Sensitive Latch,\
when active, will cause the Word Search to only match a string if all the\
characters match the search argument exactly. When the Case Sensitive Latch\
is in-active, the upper or lower case of the string will be disreguarded.\
The Case Sensitive Latch is toggled by the Case Sensitive instruction.
\l
	Page Only Latch:
\l6	The Page Only Latch, when active, causes the Word Search to operate\
on the current page only. If the Page Only Latch is off, and the starting\
page is a Menu Page, the search will include the starting page and all of\
it's Descendant Pages. The Page Only Latch is toggled by the Page Only\
instruction.

	When you execute a Word Search the General Input Window will appear\
requesting a search string. A word search instruction\
starts it's search on the top displayed line. You may abort the instruction\
at any time with the ESCAPE key. When CH has found the string being searched the\
string will be highlighted. 

	If an entire group\
is being checked, and the current page does not contain the search argument,\
the next page in the group will be checked. The operation will continue\
through the group, and any sub-groups, until a match is found or the\
last page of the group has been checked.

	Continue Word Search:
\l6	Word searches may be continued in\
either direction from the highlighted line using the Continue Word Search\
Foreward and Continue Word Search Backward instructions. 

	If you execute a Continue Word Search and the displayed page\
is not the last page found with the Word Search, a new search will be initiated\
using the original word. The new search will check either the current page or\
an entire group, depending on the Page Only Latch and the current page being\
a Menu Page.
\l
	
\p Page to page


	Instructions permit the following page to page movements.

	From any page you may go directly to:
\l6A.  the Base Page.
B.  it's Parent Page.
C.  the previous Sibling.
D.  the next Sibling.
\l
	From a Parent Page you may go directly to:
\l6A.  the first Child Page using the Down to Child One instruction.
B.  Any child by using the proper numeric keys.
  
\p Text Files


	A Text File is any ASCII file that has not been formatted for use by\
CH. A Text File may be displayed as if it were a\
Page of a Data File. You use the scroll gadget and the scrolling\
keys to display a Text File the same as you would a Page of a CH data\
file. Text Files are accessed in one of two ways. First, if the file\
is loaded from an External Text Page Spec. Second, if it is accessed\
from a Directory Menu Page.

	Text Files do not use the CH display options such as Word Wrap and\
Paragraph Indent, etc. A file accessed as a Text File will be displayed\
exactly as it is found. If a Data File is accessed as a Text File it\
will be treated as a single page and\
will show all of it's special characters ("\\p", "\\w", "\\l#", etc.) when\
displayed.
\r\Files/Page Specifiers/External Text

\p Marks


	Marks provide a way of saving a specific page and line location and\
accessing that location at any time. You may set up to ten Marks at one time.\
The function keys are used for setting, clearing and displaying Marks.

	In order to set a Mark display the page at the line you wish to\
mark. Hold down the shift key and press a funtion key that is not being\
used. A  message will appear saying "Mark set". If the function key\
already has a Mark set CH will not allow a new Mark to be set until the\
first Mark is  cleared. You will get the message "You must clear the\
current Mark first."

	To clear a single Mark hold down the alternate or control key and press the\
desired function key. An Instruction is provided to clear all Marks.

	To display a Mark press the desired function key.

\p History Buffer


	The History buffer allows an easy method of accessing a previous\
page after an instruction that breaks the normal Parent-Child chain.\
Normally you would travel from Parent to Child to Next,\
etc. To return from this type of instruction just requires doing the\
opposite instruction type (displaying a Parent Page after a Child Page\
instruction, displaying the Previous Page after a Next Page instruction). Some\
instructions (multi-level Page Search,\
Mark Display, etc.) cannot be reversed in this way.

	The History Buffer may be set to save any number of pages you wish.\
Use the History Buffer Positions Instructions to set this number. Access to the\
History pages is provided with the use of the Last History Page and Next\
History Page instructions. The first time the Last History Page instruction is\
executed the last page that was displayed, previous to the\
current page, will be re-displayed. You may execute the Last History Page\
instruction repeatedly to go back through the pages you have accessed.

	While viewing the History buffer you may use the Next History Page\
instruction to access the next page in the buffer.

	A page arrived at via a Mark or History display will not be placed in the\
history buffer allowing you to return to your original page after\
displaying a Mark or group of Marks with a single History instruction.

	Displaying any new page breaks you out of the History buffer display.\
The new page becomes the first History Buffer page. 

	The History page is cleared when a file is unloaded from memory that\
is necessary to display it.\
These are the files containing the History page itself or one of it's Ancestor Pages.\
Instructions that unload files include\
Delete a File, Clear Unused Files, Clear Unused and Mark Files, Restart,\
or Leave the DW and return to Standby Mode with Auto Clear enabled.
\rMemory Management

\p Related Items


	The Related Item instruction allows jumping immediately to another page\
found in the Related Item list. A page with Related Items is indicated\
by the gadget labeled "RI" on the left side of the DW.\

	If the current page has any Related Items associated with it after\
the Related Item instruction is initiated a window will appear on top\
of the DW. This Instruction may be initiated with either it's command\
(see the Help Page), or by clicking on the "RI" DW gadget. In\
the Related Item window will\
be a list of Related Items for this page. The first page will be\
highlighted. Use the up and down arrow keys to move the highlighted\
item. When the desired item is highlighted press RETURN to display\
that page. Press any other key to abort the instruction.
\rPage Search
\r\Files/Related Item Specifier

	A page can have any number of Related Items. Any items that do not\
fit on the window can be accessed by scrolling the highlighted item.\
If the highlighted item is the last item in the Related Item window\
pressing the down-arrow will scroll the items up one line and the next\
item at the bottom of the list will be highlighted. (see the Glossary\
Page for a page with multiple Related Items)
\r\Glossary

\p Word Wrap


	The Word Wrap option allows the displayed text to be adjusted for\
the size of the DW being used. While in Word Wrap mode CH will insert\
a new line character between the two words nearest the right margin. Special\
characters in the Data File facilitate the use of Word Wrap mode. Word\
Wrap is not active to file accessed as Text Files.
	
	When CH is started the Word Wrap menu option is active unless
the CH.prefs file Command specifies otherwise.

	For Word Wrap to be most useful each paragraph in the Data File\
should be on a single line or use soft returns for all but the last\
line of the paragraph. This allows CH to determine where to break each line\
of the paragraph depending on the width of the DW. For ease of editing\
the Data File two or more lines can be treated\
as a single line by CH with the use of a soft return. Soft returns are\
translated into a space when the paragraph is displayed. See\
"Files/Word Wrap Specifiers" for details.

	 Some pages depend on the page data appearing in a specific column\
and do not display with the Word Wrap\
menu option active.\
When creating the Data File you may ensure that either a line or an\
group of lines will be displayed exactly as it appears in the Data File\
reguardless of the state of the Word Wrap option using Word Wrap Specifiers.

	I have found it useful to view a page with multiple paragraphs, that\
was created either without explicit new line characters or soft returns,\
with Word Wrap off. Only the first line\
of each paragraph is visible. You may then scroll to the desired\
paragraph, then turn Word Wrap on, to read it.
\r\Data/Word Wrap Specifiers

\p Export Facility


	The Export Facility may be used to export CH formatted page data to\
a file or device (mainly the printer). Once started, it runs as a seperate\
process. You may continue accessing CH pages while Export is active on other\
pages. The Export Abort Instruction may be used to\
terminate the Export process before it is finished. The DW "XA" gadget\
indicates that the Export Facility is active.

	The Edit Export Values Instruction open a window that allows\
the setting of some values relating to the Export Facility. Other values\
are taken from the current settings (tabsize and Word Wrap).See User Input\
Windows/Edit Export Values section for details of the Export Values.
\rUser Input Windows/Edit Export Values

	To Export a page, display the page you wish to Export, then execute the\
Export Page Instruction. If you wish to Export an entire group, display the\
Menu Page of the group, then execute the Export Group Instruction. When\
Exporting a group, any sub-groups will also be sent.

	A list of a Group's Page Names may be generated using the Export\
Page List Instruction. Menu Pages will include the full path name, from\
the Base Page to the Menu Page. Child Pages will consist of the Page\
Name, indented by the tab size multiplied by the numbers of levels down.

	If the Export destination is a file, the file will have the new data\
appended to it.

	If the Export Facility loads any files, these will be\
will be cleared from memory after they are no longer needed.\
CH program termination will be delayed until Export is finished.

\p Memory Management


	When you quit the DW the current location is saved so when you re-open\
the DW you return to the same page. In order to accomplish this the\
file where this page resides must be kept in memory, along with the files\
containing each of it's Ancestor Pages. In addition all files containing\
Marks and their Ancestor Page files are retained. If the Auto Clear Latch\
is enabled, all other files read\
in during that session are considered Unused Files and are unloaded and\
their memory returned to the system. If the Auto Clear Latch is dis-abled,\
the Unused Files will only be cleared when you execute one of the following\
instructions.
\rMarks

Instructions:
\l3
	Delete File removes the file that contains\
the currently displayed page from memory, returning that memory to the\
system. The display is stepped up through the Parent Pages from the\
current page till it finds a page not in the file to be deleted.\
Two things will cause the Delete File instruction to fail.
\l6	1. The file contains a Mark or Marks.
	2. You have loaded any other files from a page of the current file.
\l3	Either of these two conditions will cause an error message to be displayed\
and the Delete File instruction to be aborted.

	Clear Unused Files removes all Unused Files from memory without\
leaving the DW.

	Clear All first clears all Marks then removes all Unused Files from\
memory without leaving the DW.

	Restart clears all Marks, clears all files, including the Base Files,\
then re-loads the Base Files and displays the Base Page.

	Toggle Auto Clear turns the Auto Clear Latch on and off.
